
#include <core/column_base_typed.hpp>

    /**********************************************************************/
    /* NOTE: Implementation of parallel hash join had to be moved to sc/core/column.cpp */
    /**********************************************************************/

namespace CoGaDB{
    
    using namespace std;

//        template <typename T>
//        void ColumnBaseTyped<T>::hash_join_pruning_thread(ColumnBaseTyped<T>* join_column, HashTable* hashtable, unsigned int* join_tids_table1, unsigned int* join_tids_table2, unsigned int thread_id, unsigned int number_of_threads){
//            ColumnBaseTyped<T>& join_column_ref = dynamic_cast< ColumnBaseTyped<T>& >(*join_column);
//            //number of elements per thread
//            unsigned int chunk_size = join_column_ref.size()/number_of_threads;
//            unsigned int begin_index=chunk_size*thread_id;
//            unsigned int end_index;
//            if(thread_id+1 == number_of_threads){
//                //process until end of input array
//                end_index=join_column_ref.size();
//            }else{
//                end_index=(chunk_size)*(thread_id+1);
//            }
//            if(!quiet && verbose && debug)
//                std::cout << "Parallel Hash Join for array of size: " << join_column_ref.size() << " thread id: " << thread_id << " chunksize: " << chunk_size << " elements  begin index: " << begin_index << " end index: " << end_index << std::endl;
//            unsigned int pos1 = begin_index;
//            unsigned int pos2 = begin_index;   
//            
//            std::pair<typename HashTable::iterator, typename HashTable::iterator> range;
//            typename HashTable::iterator it;
//            for(unsigned int i=begin_index;i<end_index;i++){
//                    range =  hashtable->equal_range(join_column_ref[i]);
//                    for(it=range.first ; it!=range.second;++it){
//                            if(it->first==join_column_ref[i]){ //(*join_column)[i]){
//                                      join_tids_table1[pos1++]=it->second;
//                                      join_tids_table2[pos2++]=i;
//                                      if(!quiet && verbose && debug)
//                                        std::cout << "match! " << it->second << ", " << i << "	"  << it->first << std::endl;
//                            }
//                    }
//            }
//        }
//        
//        
//	template<class T>
//	const PositionListPairPtr ColumnBaseTyped<T>::parallel_hash_join(ColumnPtr join_column_,unsigned int number_of_threads){
//
//		
//
//                if(join_column_->type()!=typeid(T)){
//                        std::cout << "Fatal Error!!! Typemismatch for columns " << this->name_  << " and " << join_column_->getName() << std::endl;
//                        std::cout << "File: " << __FILE__ << " Line: " << __LINE__ << std::endl;
//                        exit(-1);
//                }
//
//                shared_pointer_namespace::shared_ptr<ColumnBaseTyped<T> > join_column = shared_pointer_namespace::static_pointer_cast<ColumnBaseTyped<T> >(join_column_); //static_cast<IntColumnPtr>(column1);
//
//                PositionListPairPtr join_tids( new PositionListPair());
//                join_tids->first = PositionListPtr( new PositionList() );
//                join_tids->second = PositionListPtr( new PositionList() );
//
//                Timestamp build_hashtable_begin = getTimestamp();
//               //create hash table
//               HashTable hashtable;
//               unsigned int hash_table_size=this->size();
//               unsigned int join_column_size=join_column->size();
//
//               assert(join_column_->size()>=this->size());                        
//               unsigned int* join_tids_table1 =  new unsigned int[join_column_size];   
//               unsigned int* join_tids_table2 =  new unsigned int[join_column_size]; 
//
////               ColumnBaseTyped<T>& join_column_ref = dynamic_cast< ColumnBaseTyped<T>& >(*join_column);
//
//                for(unsigned int i=0;i<hash_table_size;i++)	
//                        hashtable.insert(std::pair<T,TID> ((*this)[i],i));
//                Timestamp build_hashtable_end = getTimestamp();
//
//                //probe larger relation
//                Timestamp prune_hashtable_begin = getTimestamp();
//		boost::thread_group threads;
//		for(unsigned int i=0;i<number_of_threads;i++){
//                    //ColumnBaseTyped<T>::hash_join_pruning_thread(join_column.get(), &hashtable, join_tids_table1, join_tids_table2, i, number_of_threads);
//                    //CoGaDB::hash_join_pruning_thread<T,HashTable>(join_column_ref, &hashtable, join_tids_table1, join_tids_table2, i, number_of_threads);
//                    //threads.add_thread(new boost::thread((&hash_join_pruning_thread<T,HashTable>),join_column_ref, &hashtable, join_tids_table1, join_tids_table2, i, number_of_threads));
//                    //ColumnBaseTyped<T>& join_column_ref, HashTable* hashtable, unsigned int* join_tids_table1, unsigned int* join_tids_table2, unsigned int thread_id, unsigned int number_of_threads)
//                    threads.add_thread(new boost::thread(boost::bind(&ColumnBaseTyped<T>::hash_join_pruning_thread, join_column.get(), &hashtable, join_tids_table1, join_tids_table2, i, number_of_threads)));
//		}
//		threads.join_all();
//                //put results in position list
//                join_tids->first->insert(join_tids->first->end(),join_tids_table1,join_tids_table1+join_column_size); //assume PK FK Join!
//                join_tids->second->insert(join_tids->second->end(),join_tids_table2,join_tids_table2+join_column_size);
//                //cleanup
//                delete join_tids_table1;
//                delete join_tids_table2;
//                
//                Timestamp prune_hashtable_end = getTimestamp();
//
//                if(!quiet && verbose && debug)
//                std::cout << "Hash Join: Build Phase: " << double(build_hashtable_end-build_hashtable_begin)/(1000*1000) << "ms"
//                          << "Pruning Phase: "  << double(prune_hashtable_end-prune_hashtable_begin)/(1000*1000) << "ms" << std::endl; 
//
//		return join_tids;
//	}

        void column_base_typed_template_instatiation(){
//                ColumnBaseTyped<int>* col_int;
//                ColumnBaseTyped<float>* col_float;
//                ColumnBaseTyped<std::string>* col_string;
            typedef ColumnBaseTyped<int> ColumnBaseTypedINT;
            typedef ColumnBaseTyped<float> ColumnBaseTypedFLOAT;
            typedef ColumnBaseTyped<std::string> ColumnBaseTypedVARCHAR;        
            
            cout << typeid(ColumnBaseTypedINT).name() << endl;
            cout << typeid(ColumnBaseTypedFLOAT).name() << endl;
            cout << typeid(ColumnBaseTypedFLOAT).name() << endl;
            
        }

}; //end namespace CoGaDB