
#pragma once

#include <core/global_definitions.hpp>
#include <core/base_column.hpp>

namespace CoGaDB{

#ifdef ENABLE_SIMD_ACCELERATION 
    const PositionListPtr simd_selection_int(int* array, unsigned int array_size,  int comparison_value, const ValueComparator comp);
    const PositionListPtr simd_selection_float(float* array, unsigned int array_size,  float comparison_value, const ValueComparator comp);
#endif
    
}; //end namespace CoGaDB

