#pragma once

#include <core/base_column.hpp>
#include <core/lookup_array.hpp>

namespace CoGaDB{

class LookupColumn{
	public:


	LookupColumn(TablePtr table, PositionListPtr tids);

//	template <typename T>
//	const shared_pointer_namespace::shared_ptr<LookupArray<T> > getColumnbyName(std::string s) const;

	const ColumnPtr getLookupArrayforColumnbyName(const Attribut& attr) const;

        //const ColumnVectorPtr getDenseValueColumns() const;
        
	const ColumnVectorPtr getLookupArrays() const;

//	const ColumnPtr getLookupArrayforColumn(std::string column_name);

	const TablePtr getTable() const throw();

	const PositionListPtr getPositionList() const throw();

	const shared_pointer_namespace::shared_ptr<LookupColumn> aggregate(const LookupColumn& lookup_col) const;
	/* \brief returns copy of LookupColumn*/
	const shared_pointer_namespace::shared_ptr<LookupColumn> copy() const;

	protected:
	TablePtr table_;
	PositionListPtr tids_;
};

//	typedef LookupColumn::PositionListPtr PositionListPtr;
	typedef shared_pointer_namespace::shared_ptr<LookupColumn> LookupColumnPtr;


	//template <typename T>
//	const ColumnPtr LookupColumn::getLookupArrayforColumnbyName(const Attribut& attr) const{
//		
//		ColumnPtr column = table_->getColumnbyName(attr.second);
//		if(!column){
//			return ColumnPtr(); //shared_pointer_namespace::shared_ptr<LookupArray<T> >(  ); //return NULL Pointer
//		}
//		if(column->getType()!=attr.first){
//			cout << "FATAL ERROR: FOUND Column " << column->getName() << " of Table " << table_->getName() << " does not match Attribut type for LookupColumn!" << endl;
//			cout << "File: " << __FILE__ << " Line:" << __LINE__ << endl;
//			return ColumnPtr(); //return NULL Pointer
//		}

//		if(typeid(T)!=column->type()){
//			return shared_pointer_namespace::shared_ptr<LookupArray<T> >(  ); //return NULL Pointer
//		}

//		return shared_pointer_namespace::shared_ptr<LookupArray<T> >( new LookupArray<T>(column,tids_) );
//	}


}; //end namespace CogaDB

